Gecode::Search::Seq::LDS< Tracer > Class Template Reference

Limited discrepancy search engine implementation. More...

`#include <lds.hh>`

## Public Member Functions

| LDS (Space *s, const Options &o)
| Initialize for space s with options o.
virtual Space * | next (void)
| Return next solution (NULL, if none exists or search has been stopped).
virtual Statistics | statistics (void) const
| Return statistics.
void | constrain (const Space &b)
| Constrain future solutions to be better than b (should never be called).
void | reset (Space *s)
| Reset engine to restart at space s.
virtual bool | stopped (void) const
| Check whether engine has been stopped.
virtual | ~LDS (void)
| Destructor.
Public Member Functions inherited from Gecode::Search::Engine
virtual NoGoods & | nogoods (void)
| Return no-goods (the no-goods are empty).
virtual | ~Engine (void)
| Destructor.

## Protected Attributes

Options | opt
| Search options.
Probe< Tracer > | e
| The probe engine.
Space * | root
| Root node for problem.
unsigned int | d
| Current discrepancy.
bool | no_solution
| Solution found for current discrepancy.

## Additional Inherited Members

Static Public Member Functions inherited from Gecode::HeapAllocated
static void * | operator new (size_t s)
| Memory management.
static void | operator delete (void *p)
| Free memory allocated from heap.

## Detailed Description

template<class Tracer>
class Gecode::Search::Seq::LDS< Tracer >

Limited discrepancy search engine implementation.

Definition at line 105 of file lds.hh.

## Constructor & Destructor Documentation

## LDS()

template<class Tracer>

Gecode::Search::Seq::LDS< Tracer >::LDS | ( | Space * | s,
|  | const Options & | o )

inline

Initialize for space s with options o.

Definition at line 272 of file lds.hpp.

## ~LDS()

template<class Tracer>

Gecode::Search::Seq::LDS< Tracer >::~LDS | ( | void |  | ) |

virtual

Destructor.

Definition at line 345 of file lds.hpp.

## Member Function Documentation

## next()

template<class Tracer>

Space * Gecode::Search::Seq::LDS< Tracer >::next | ( | void |  | ) |

virtual

Return next solution (NULL, if none exists or search has been stopped).

Implements Gecode::Search::Engine.

Definition at line 289 of file lds.hpp.

## statistics()

template<class Tracer>

Statistics Gecode::Search::Seq::LDS< Tracer >::statistics | ( | void |  | ) | const

virtual

Return statistics.

Implements Gecode::Search::Engine.

Definition at line 315 of file lds.hpp.

## constrain()

template<class Tracer>

void Gecode::Search::Seq::LDS< Tracer >::constrain | ( | const Space & | b | ) |

inline virtual

Constrain future solutions to be better than b (should never be called).

Reimplemented from Gecode::Search::Engine.

Definition at line 339 of file lds.hpp.

## reset()

template<class Tracer>

void Gecode::Search::Seq::LDS< Tracer >::reset | ( | Space * | s | ) |

inline virtual

Reset engine to restart at space s.

Reimplemented from Gecode::Search::Engine.

Definition at line 322 of file lds.hpp.

## stopped()

template<class Tracer>

bool Gecode::Search::Seq::LDS< Tracer >::stopped | ( | void |  | ) | const

virtual

Check whether engine has been stopped.

Implements Gecode::Search::Engine.

Definition at line 309 of file lds.hpp.

## Member Data Documentation

## opt

template<class Tracer>

Options Gecode::Search::Seq::LDS< Tracer >::opt

protected

Search options.

Definition at line 108 of file lds.hh.

## e

template<class Tracer>

Probe<Tracer> Gecode::Search::Seq::LDS< Tracer >::e

protected

The probe engine.

Definition at line 110 of file lds.hh.

## root

template<class Tracer>

Space* Gecode::Search::Seq::LDS< Tracer >::root

protected

Root node for problem.

Definition at line 112 of file lds.hh.

## d

template<class Tracer>

unsigned int Gecode::Search::Seq::LDS< Tracer >::d

protected

Current discrepancy.

Definition at line 114 of file lds.hh.

## no_solution

template<class Tracer>

bool Gecode::Search::Seq::LDS< Tracer >::no_solution

protected

Solution found for current discrepancy.

Definition at line 116 of file lds.hh.

The documentation for this class was generated from the following files:

- gecode/search/seq/lds.hh
- gecode/search/seq/lds.hpp